# P2 "Hello LM335Z" MicroPython demo, by Team-oz 1 DEC 2020
# Connect LM335Z between ground and Pin 16.   10k trimmer potentiometer optional.
# P2 is configured to provide 1mA pull-up current source.  LM335Z outputs ~10mv per K (2.98v at 25 C room temp)

import machine                                                          # machine contains P2 specific functions, eg Pin for I/O pin access
import time                                                             # time contains time delay routines (sleep)

p=machine.Pin(16)                                                       # our LM335Z is connected between pin 16 and GND
p.wrpin(p.P_HIGH_1MA | p.P_ADC_1X| p.P_COUNT_HIGHS | p.P_TT_01  )       # bias the LM335Z with a 1mA current source. Use ADC in 1x gain to observe
p.wxpin(1000000)                                                        # each ADC bucket accumulates for 1 million clocks (~252 Hz)
p.on()                                                                  # start the current source and observations
time.sleep_ms(300)                                                      # give it time to get first readings

r=range(101)                                                            # plot 100 readings to Mu plot window
baseline=p.rdpin()
print('baseline=' , baseline)                                           # record a baseline ('zero point')
for i in r:
    print('(',p.rdpin()-baseline,')')                                   # Mu plot needs values in normal braces to work.  Offset so that 0 = baseline
    time.sleep_ms(300)                                                  # take around 6 readings per second (expt lasts 30 seconds)

p.pinfloat()                                                            #turn off current source, we're done.
